


var ci cp rn rk rl qk qh hi hp pi pis delt1 delt2 nu mu lo wp wi ni np k ik ih 
    y mc b g h c ucp uci uhp uhi ec eh ey er eq eik eih
    KIH dy dti_1 dti_2 lo_growth lo_gdp spread dc dih dik dqh dqk dlo  
    dh dhi dhp dk ddti_1 ddti_2 dlo_gdp rr_2 rr_3 pi_a r_a rn_a rl_a dci dcp dni dnp;

varexo eps_g eps_er eps_ec eps_eh eps_ey eps_eq eps_eik eps_eih;


parameters BETAP BETAI ALPHA DELK TETA ETA PISS PSI PHI A EPSIL EPSILW ZETAK ZETAH 
           MH GAMA_R GAMA_PI GAMA_Y RHO_G RHO_R RHO_C RHO_H RHO_Y 
          GYSS LOYSS  DELH KIN;


load parameterfile_housing;

set_param_value('BETAP',BETAP);
set_param_value('BETAI',BETAI);
set_param_value('ALPHA',ALPHA);
set_param_value('ETA',ETA);
set_param_value('DELK',DELK);
set_param_value('TETA',TETA);
set_param_value('PISS',PISS);
set_param_value('PSI',PSI);
set_param_value('PHI',PHI);
set_param_value('A',A);
set_param_value('EPSIL',EPSIL);
set_param_value('EPSILW',EPSILW);
set_param_value('ZETAK',ZETAK);
set_param_value('ZETAH',ZETAH);
set_param_value('MH',MH);

set_param_value('GAMA_R',GAMA_R);
set_param_value('GAMA_PI',GAMA_PI);
set_param_value('GAMA_Y',GAMA_Y);


set_param_value('RHO_G',RHO_G);
set_param_value('RHO_R',RHO_R);
set_param_value('RHO_C',RHO_C);
set_param_value('RHO_H',RHO_H);
set_param_value('RHO_Y',RHO_Y);
set_param_value('GYSS',GYSS);
set_param_value('LOYSS',LOYSS);

set_param_value('DELH',DELH);


set_param_value('KIN',KIN);


model;




KIH = STEADY_STATE(KIH);

//%Marginal utilities

ucp = (ec*(1-A))/(cp-A*cp(-1));

uci = (ec*(1-A))/(ci-A*ci(-1));

uhp = (eh*KIH)/hp;

uhi = (eh*KIH)/hi;

//%Patient

ucp = BETAP * ucp(+1)*((rn)/pi(+1));

qk * ucp = BETAP * ucp(+1)*(rk(+1) + qk(+1)*(1-DELK));

qh * ucp  = uhp + eq * BETAP *(1-DELH)* qh(+1)* (ucp(+1));

//%Impatient

qh*uci = uhi + eq*(BETAI * (1-DELH) * qh(+1) * (uci(+1)) + mu *uci* (MH*qh(+1)*pi(+1)/(1+rl)));

mu = 1- BETAI * (uci(+1)/uci)*((1+rl)/pi(+1));

ci  =  wi*ni + lo - qh * (hi-(1-DELH)*hi(-1)) - (1+rl(-1))* (lo(-1)/pi); 

lo = MH * qh(+1) * hi * pi(+1)/(1+rl); 




rl(+1) = rn(+1)-1 ; 

//%Capital and housing investment

k = (1-DELK) * k(-1) + eik*(1 - (ZETAK/2)*((ik/ik(-1))-1)^2) * ik;

qk = (1 - BETAP * (ucp(+1)/ucp)* ZETAK * qk(+1) * ((ik(+1)/ik)-1) * (ik(+1)/ik)^2)/(1-(ZETAK/2)*((ik/ik(-1))-1)^2 - ZETAK*((ik/ik(-1))-1)*(ik/ik(-1)));

h = (1-DELH) * h(-1) + eih*(1 - (ZETAH/2)*((ih/ih(-1))-1)^2) * ih;

qh = (1 - BETAP * (ucp(+1)/ucp)* ZETAH * qh(+1) * ((ih(+1)/ih)-1) * (ih(+1)/ih)^2)/(1-(ZETAH/2)*((ih/ih(-1))-1)^2 - ZETAH*((ih/ih(-1))-1)*(ih/ih(-1)));


//%Price setting

pi = ((1-PSI)*(pis)^(1-EPSIL) + PSI)^(1/(1-EPSIL)); 

pis = (EPSIL/(EPSIL-1))* pi* (delt1/delt2);

delt1 = ucp*mc*y + BETAP * PSI * (pi(+1)^EPSIL)* delt1(+1);  //auxiliary terms

delt2 = ucp*y + BETAP * PSI * (pi(+1)^(EPSIL-1))* delt2(+1);  //auxiliary terms

nu = (1-PSI)*(pis/pi)^(-EPSIL) + PSI * pi^(EPSIL)* nu(-1);   //aggregate price dispresion  
  
//%Wage setting

wp = (KIN*np^PHI)/ucp; 

wi = (KIN*ni^PHI)/uci; 


//%Goods production and factors prices

y = (ey * (k(-1)^ALPHA)* ((ni^ETA)* np^(1-ETA))^(1-ALPHA))/nu;

rk = ALPHA * mc * (y/k(-1));

wi * ni = (1-ALPHA) * ETA * mc * y ;

wp * np  = (1-ALPHA)*(1-ETA) * mc * y ;

//%Resource constraints and General equilibrium

y = c + qk * (k - (1-DELK) * k(-1)) + qh * (h - (1-DELH) * h(-1)) + g ;

c = cp + ci;

h = hp + hi;

//%Government

b = (rn(-1))* b(-1)/pi + g;


//%Monetary policy 

rn =  ((rn(-1))^GAMA_R)*(((STEADY_STATE(rn))*((pi/STEADY_STATE(pi))^GAMA_PI)*(y/STEADY_STATE(y))^GAMA_Y)^(1-GAMA_R))* er;

//rn =  (STEADY_STATE(rn))*((rn(-1)/STEADY_STATE(rn))^GAMA_R)*(((pi/STEADY_STATE(pi))^GAMA_PI)*(y/STEADY_STATE(y))^GAMA_Y)* er;

 
                         
//% Exogenous variables and Shocks

log(g) = RHO_G * log(g(-1)) + (1-RHO_G) * log(STEADY_STATE(g)) + eps_g ;

log(er) = RHO_R * log(er(-1)) + eps_er ;

log(ec) = RHO_C * log(ec(-1)) + eps_ec ;

log(eh) = RHO_H * log(eh(-1)) + eps_eh ;

log(ey) = RHO_Y * log(ey(-1)) + eps_ey ;

log(eq) = RHO_Y * log(eq(-1)) + eps_eq ;

log(eik) = RHO_Y * log(eik(-1)) + eps_eik ;

log(eih) = RHO_Y * log(eih(-1)) + eps_eih ;

//% Definitional equations and Varibales in logdeviation from SS

dti_1 = lo/(wi*ni);
dti_2 = lo/(wi*ni);
lo_growth = (lo/lo(-1))-1;
lo_gdp = (lo/y);
spread = rl-rn;



//incometotal = wi*ni+wp*np;
//dtitotal_1 = md/incometotal;
//dtitotal_2 = md/(incometotal+tr);
//ddtitotal_1 = (dtitotal_1/STEADY_STATE(dtitotal_1))-1;
//ddtitotal_2= (dtitotal_2/STEADY_STATE(dtitotal_2))-1;

dy = (y/STEADY_STATE(y))-1;
dc = (c/STEADY_STATE(c))-1;
dih = (ih/STEADY_STATE(ih))-1;
dik = (ik/STEADY_STATE(ik))-1;
dqh = (qh/STEADY_STATE(qh))-1;
dqk = (qk/STEADY_STATE(qk))-1;

dlo = (lo/STEADY_STATE(lo))-1;


dh = (h/STEADY_STATE(h))-1;
dhi = (hi/STEADY_STATE(hi))-1;
dhp = (hp/STEADY_STATE(hp))-1;
dk = (k/STEADY_STATE(k))-1;
ddti_1 = (dti_1/STEADY_STATE(dti_1))-1;
ddti_2= (dti_2/STEADY_STATE(dti_2))-1;
dlo_gdp= (lo_gdp/STEADY_STATE(lo_gdp))-1;
dci = (ci/STEADY_STATE(ci))-1;
dcp = (cp/STEADY_STATE(cp))-1;
dni = (ni/STEADY_STATE(ni))-1;
dnp = (np/STEADY_STATE(np))-1;

//% Annualised levels

rr_2 = (rn-(pi-1))*4; 
rr_3 = (rn-1)*4;
pi_a = (pi-1)*4;
r_a = rn*4; 
rn_a = rn*4;
rl_a = rl*4;


end ;

steady;

check;


//resid(1);


shocks;

var eps_er ; stderr 0.001  ;

end;



stoch_simul(order=1,irf=20) dy dc dci dcp dh dih dik dqh dlo pi_a r_a er rn dni dnp pis delt1 delt2 ucp mc;




