



BETAP = 0.993;
BETAI = 0.988; 
ALPHA = 0.224 ; 
ETA = 0.82; 
DELK = 0.025; 
TETA = 0.5; 
PISS = 1.005; 
PSI = 0.75;
PHI = 1; 
A = 0.46; 
EPSIL = 6; 
EPSILW = 3; 
ZETAK = 10; 
ZETAH = 10; 
MH = 0.70; 
KTAU = 0.9; 
KI = 11; 
MB = 1/100; 
GAMA_R = 0.8; 
GAMA_PI = 2.5; 
GAMA_Y =1.5 ; 
GYSS = 0.2; 
RHOB = 0.5; 
RHO_G = 0.9;
RHO_R = 0.9 ;
RHO_C = 0.9;
RHO_H = 0.9;
RHO_Y = 0.9;
%RMSS = 5/100;
BYSS = 0.3;
KBYSS = 1.8;
CYSS = 0.40;
DELH = 0.01;
HIMDSS = 1.04;
MDYSS = 1.04;
KIN = 5;
KAP = 0.018;
ZETA = 0.04;

pi=PISS;
qk = 1;
qh = 1;
ni =1/3;
np = 1/3;
pis = (((pi^(1-EPSIL))-PSI)/(1-PSI))^(1/(1-EPSIL));
nu = ((1-PSI)*((pis/pi)^(-EPSIL))/(1-PSI*pi^(EPSIL))); 
mc = ((EPSIL-1)/EPSIL)*(pis/pi)*((1-BETAP*PSI*(pi^EPSIL))/(1-BETAP*PSI*(pi^(EPSIL-1))));
rn = pi/BETAP; 
r = rn-1;
rr = rn/pi;
rk = (1/BETAP)- (1-DELK);
rl = r + MB;
K_Y = ALPHA * mc/rk;
%G_Y = GYSS; 

%B_Y = BYSS;
KB_Y = KBYSS ;
%MD_Y = MDYSS;


IK_Y = DELK* K_Y; 


LO_Y = KB_Y/KTAU; 

MD_Y=LO_Y/(1-(1-KAP)/pi);

D_Y = (1-KTAU)*LO_Y;

DELB = (LO_Y*(rl-r*(1-KTAU))+KB_Y*(1-pi))/(KB_Y); %%%%

LAMB_Y = KB_Y * (pi- (1-DELB)); 

LO_MD = LO_Y/MD_Y;

rm = ((LO_MD + ZETA*(1-LO_MD))/(1-(1-ZETA)*(1-LO_MD)))*rl;


omr = (-BETAI/(pi-BETAI*(1-ZETA)*(1-KAP)));

omd = ( (-BETAI*((rm+KAP+MH*(1-KAP))/pi)) + (((-pi+BETAI*(1-KAP)*(1-ZETA))*rm+BETAI*(1-KAP)*(ZETA-MH)*rl)/pi)*omr)/(1-(BETAI*(1-KAP)*(1-MH)/pi)); 

mu = 1 + omd + omr*rl; 

BB = 1-BETAP*(1-DELH);
DD = 1-BETAI*(1-DELH)- mu*MH*pi*(1-DELH)/(1+rl);

GG = (1-(1-MH)*(1-KAP)/pi)/(MH*pi*(1-DELH)*(1/(1+rl)));

%HI_Y = GG*MD_Y;

y = (K_Y^(ALPHA/(1-ALPHA)))* ((ni^ETA) * np^(1-ETA)) * (1/nu)^(1/(1-ALPHA));

wp = (1-ALPHA)* (1-ETA)* mc* y/np;

wi = (1-ALPHA)* ETA* mc* y/ni;

wps = wp * ((1-TETA*pi^(EPSILW-1))/(1-TETA))^(1/(1-EPSILW));

wis = wi * ((1-TETA*pi^(EPSILW-1))/(1-TETA))^(1/(1-EPSILW));


omp1 = (KIN *((wp)^(EPSILW*(1+PHI)))*(np)^(1+PHI))/(1-BETAP * TETA * (pi^(EPSILW*(1+PHI))));

omi1 = (KIN *((wi)^(EPSILW*(1+PHI)))*(ni)^(1+PHI))/(1-BETAI * TETA * (pi^(EPSILW*(1+PHI))));


%omp2 = ((EPSILW/(EPSILW-1)) * (omp1/wps^(1+PHI*EPSILW)));

%omi2 = ((EPSILW/(EPSILW-1)) * (omi1/wis^(1+PHI*EPSILW)));


EE = ((1-TETA*pi^(EPSILW-1))/(1-TETA))^((1+EPSILW*PHI)/(1-EPSILW));
FF = (EPSILW/(EPSILW-1))*((1-BETAI*TETA*pi^(EPSILW-1))/(1-BETAI*TETA*pi^(EPSILW*(1+PHI))));
FFF= (EPSILW/(EPSILW-1))*((1-BETAP*TETA*pi^(EPSILW-1))/(1-BETAP*TETA*pi^(EPSILW*(1+PHI))));

cp= EE*wp/(FFF*KIN*np^(PHI));

ci= EE*wi/(FF*KIN*ni^(PHI));

omp2 = (((wp)^(EPSILW*(1)))*(np)^(1))/(cp*(1-BETAP * TETA * (pi^(EPSILW-1))));

omi2 = (((wi)^(EPSILW*(1)))*(ni)^(1))/(ci*(1-BETAI * TETA * (pi^(EPSILW-1))));


%cp = ((wp^(EPSILW))*np)/((1- BETAP * TETA * (pi^(EPSILW-1)))*omp2);

%ci = ((wi^(EPSILW))*ni)/((1- BETAI * TETA * (pi^(EPSILW-1)))*omi2);



CI_Y = ci/y;
CP_Y = cp/y;


EE = ((1-TETA*pi^(EPSILW-1))/(1-TETA))^((1+EPSILW*PHI)/(1-EPSILW));

FF = (EPSILW/(EPSILW-1))*((1-BETAI*TETA*pi^(EPSILW-1))/(1-BETAI*TETA*pi^(EPSILW*(1+PHI))));

%CI_Y = ((1-ALPHA)*ETA*mc)/(KIN*(ni^(1+PHI))*(FF/EE));

%CP_Y = ((1-ALPHA)*(1-ETA)*mc)/(KIN*(np^(1+PHI))*(FF/EE));

%hi = (lo + MH*(1-KAP)*m/pi)/(MH*pi*(1-DELH)/(1+rl));



HI_Y = (LO_Y + MH*(1-KAP)*MD_Y/pi)/(MH*pi*(1-DELH)/(1+rl));

KIH = (HI_Y/CI_Y)*DD; %%%%%%

HP_Y = CP_Y * KIH/BB;

H_Y = HI_Y +HP_Y;

IH_Y = DELH*H_Y;

C_Y = CP_Y + CI_Y;

TRI_Y = CI_Y-(1-ALPHA)*ETA*mc - LO_Y + DELH*HI_Y+((rm+KAP)/pi)*MD_Y;

TR_Y = TRI_Y/(1-ETA);

TRP_Y = (ETA)*TR_Y;

%G_Y = 1-C_Y-IK_Y-IH_Y-(DELB/pi)*KB_Y;

B_Y = (1-C_Y-IK_Y-IH_Y-(DELB/pi)*KB_Y+TR_Y)/(1-rn/pi);

G_Y = B_Y*(1-(rn)/pi)-TR_Y;

%H_Y = (CP_Y/BB + CI_Y/DD)*KIH;


EE = ((1-TETA*pi^(EPSILW-1))/(1-TETA))^((1+EPSILW*PHI)/(1-EPSILW));

FF = (EPSILW/(EPSILW-1))*((1-BETAI*TETA*pi^(EPSILW-1))/(1-BETAI*TETA*pi^(EPSILW*(1+PHI))));

%ni = ((1-ALPHA)*ETA*mc/(KIN*CI_Y*(FF/EE)))^(1/(1+PHI));
%np = (((1-ALPHA)*(1-ETA)*mc)/(KIN*CP_Y*(FF/EE)))^(1/(1+PHI));




RHOTR = TR_Y + RHOB*B_Y; %%%% steady

k = K_Y * y;
g = G_Y *y;
b = B_Y *y;
kb = KB_Y *y;
c = C_Y *y;
tr = TR_Y *y;
ik = IK_Y *y;
lo = LO_Y *y;
ih = IH_Y *y;
h = H_Y *y;
lamb = LAMB_Y *y;
d = D_Y *y;
md = MD_Y *y;
ci = CI_Y *y;
cp = CP_Y *y;
hi = HI_Y *y;
hp = HP_Y *y;

tri = TRI_Y * y;
trp = TRP_Y * y;

ucp = 1/cp;
uci = 1/ci;
uhp = KIH/hp;
uhi = KIH/hi;

delt1 = ucp*mc*y/(1-BETAP*PSI*pi^(EPSIL));

delt2 = ucp*y/(1-BETAP*PSI*pi^(EPSIL-1));

%wp = KIN*cp*(np^PHI)*FF/EE; %%
%wi = KIN*ci*(ni^PHI)*FF/EE; %%





%omp2 = (ucp* ((wp)^(EPSILW))*(np))/(1- BETAP * TETA * (pi^(EPSILW-1)));





%omi2 = (uci* ((wi)^(EPSILW))*(ni))/(1- BETAI * TETA * (pi^(EPSILW-1)));




ec = 1; 
eh = 1;
ey = 1;
er = 1; 
