
function [ys,check]=housing_steadystate(junk,ys);

global M_

parameterfile_housing

nparams = size(M_.param_names,1);
for icount = 1:nparams
    eval(['M_.params(icount) = ',M_.param_names(icount,:),';'])
end

check = 0;

pi=PISS;
qk = 1;
qh = 1;

pis = (((pi^(1-EPSIL))-PSI)/(1-PSI))^(1/(1-EPSIL));
nu = ((1-PSI)*((pis/pi)^(-EPSIL))/(1-PSI*pi^(EPSIL))); 
mc = ((EPSIL-1)/EPSIL)*(pis/pi)*((1-BETAP*PSI*(pi^EPSIL))/(1-BETAP*PSI*(pi^(EPSIL-1))));
rn = pi/BETAP; 

rk = (1/BETAP)- (1-DELK);
rl = rn-1 ;
K_Y = ALPHA * mc/rk;

IK_Y = DELK* K_Y; 

LO_Y = LOYSS;

G_Y = GYSS;

B_Y = G_Y/(1-(rn)/pi);

mu = 1-BETAI*(1+rl)/pi; 

BB = 1-BETAP*(1-DELH);
DD = 1-BETAI*(1-DELH)- mu*MH*pi/(1+rl);



HI_Y = (LO_Y)/(MH*pi/(1+rl));

CI_Y = (1-ALPHA)*ETA*mc + LO_Y*(1-(1+rl)/pi) - DELH*HI_Y;

KIH = (HI_Y/CI_Y)*DD; %%%%%%



CP_Y = (1-CI_Y-IK_Y-DELH*HI_Y-G_Y)/(1+DELH*(KIH/BB));

HP_Y = CP_Y * KIH/BB;

H_Y = HI_Y +HP_Y;

IH_Y = DELH*H_Y;

C_Y = CP_Y + CI_Y;

np = (((1-ALPHA)*(1-ETA)*mc)/(KIN*CP_Y))^(1/(1+PHI));

ni = (((1-ALPHA)*(ETA)*mc)/(KIN*CI_Y))^(1/(1+PHI));

y = (K_Y^(ALPHA/(1-ALPHA)))* ((ni^ETA) * np^(1-ETA)) * (1/nu)^(1/(1-ALPHA));

wp = (1-ALPHA)* (1-ETA)* mc* y/np;

wi = (1-ALPHA)* ETA* mc* y/ni;


ci = CI_Y*y;

cp = CP_Y*y;








k = K_Y * y;
g = G_Y *y;
b = B_Y *y;

c = C_Y *y;

ik = IK_Y *y;
lo = LO_Y *y;
ih = IH_Y *y;
h = H_Y *y;



hi = HI_Y *y;
hp = HP_Y *y;


ucp = 1/cp;
uci = 1/ci;
uhp = KIH/hp;
uhi = KIH/hi;

delt1 = ucp*mc*y/(1-BETAP*PSI*pi^(EPSIL));

delt2 = ucp*y/(1-BETAP*PSI*pi^(EPSIL-1));


ec = 1; 
eh = 1;
ey = 1;
er = 1; 
eq = 1;
eik = 1;
eih = 1;
dy = 0;
dti_1 = lo/(wi*ni);
dti_2 = lo/(wi*ni);
lo_growth=0;
lo_gdp = (lo/y);
spread = rl-rn;

dc = 0; 
dih = 0;
dik  = 0;
dqh = 0;
dqk = 0; 

dlo = 0;
  
dh = 0;
dhi = 0;
dhp = 0;
dk = 0;
ddti_1 = 0;
ddti_2 = 0;
dlo_gdp = 0;
dkb_to_asset = 0;
rr_2 = (rn-(pi-1))*4; 
rr_3 = (rn-1)*4;
pi_a = (pi-1)*4;
r_a  = rn*4;
rn_a = rn*4;
rl_a = rl*4;

dci = 0;
dcp = 0;
dni = 0;
dnp = 0;

ys = [ ci 
    cp 
    rn 
    rk 
    rl 
    qk 
    qh 
    hi 
    hp 
    pi 
    pis 
    delt1 
    delt2 
    nu 
    mu 
    lo 
    wp 
    wi 
    ni 
    np 
    k 
    ik 
    ih 
    y 
    mc 
    b 
    g 
    h 
    c 
    ucp 
    uci 
    uhp 
    uhi 
    ec 
    eh 
    ey 
    er 
    eq
    eik
    eih
    KIH
    dy
    dti_1 
    dti_2 
    lo_growth 
    lo_gdp 
    spread 
    dc 
    dih 
    dik 
    dqh 
    dqk 
    dlo 
    dh 
    dhi 
    dhp 
    dk 
    ddti_1 
    ddti_2 
    dlo_gdp 
    rr_2 
    rr_3 
    pi_a 
    r_a 
    rn_a
    rl_a 
    dci 
    dcp
    dni
    dnp];


